diff --git a/src/Makefile.am b/src/Makefile.am
index 62fe1fc..c687a05 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -13,9 +13,7 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-GETOPT_C = getopt.c getopt1.c
-
-noinst_HEADERS = cddb.h getopt.h util.h
+noinst_HEADERS = cddb.h util.h
 
 ####################################################
 # Things to make the utility/diagnostic programs
@@ -25,20 +23,20 @@ CDDB_LIBS=@CDDB_LIBS@
 CDDA_PLAYER_LIBS=@CDDA_PLAYER_LIBS@
 
 if BUILD_CDDA_PLAYER
-cdda_player_SOURCES = cdda-player.c cddb.c cddb.h $(GETOPT_C)
+cdda_player_SOURCES = cdda-player.c cddb.c cddb.h
 cdda_player_LDADD   = $(LIBCDIO_LIBS) $(CDDB_LIBS) $(CDDA_PLAYER_LIBS)
 bin_cdda_player     = cdda-player
 endif
 
 if BUILD_CD_DRIVE
-cd_drive_SOURCES = cd-drive.c util.c util.h $(GETOPT_C)
+cd_drive_SOURCES = cd-drive.c util.c util.h
 cd_drive_LDADD   =  $(LIBISO9660_LIBS) $(LIBCDIO_LIBS) $(LTLIBICONV)
 bin_cd_drive     = cd-drive
 man_cd_drive         = cd-drive.1
 endif
 
 if BUILD_CDINFO
-cd_info_SOURCES = cd-info.c cddb.c cddb.h util.c util.h $(GETOPT_C)
+cd_info_SOURCES = cd-info.c cddb.c cddb.h util.c util.h
 cd_info_LDADD   =  $(LIBISO9660_LIBS) $(LIBCDIO_LIBS) $(CDDB_LIBS) $(VCDINFO_LIBS) $(LTLIBICONV)
 bin_cd_info     = cd-info 
 man_cd_info     = cd-info.1
@@ -51,27 +49,27 @@ bin_cdinfo_linux     = cdinfo-linux
 endif
 
 if BUILD_CD_READ
-cd_read_SOURCES = cd-read.c util.c util.h $(GETOPT_C)
+cd_read_SOURCES = cd-read.c util.c util.h
 cd_read_LDADD   = $(LIBISO9660_LIBS) $(LIBCDIO_LIBS) $(LTLIBICONV)
 bin_cd_read     = cd-read 
 man_cd_read     = cd-read.1
 endif
 
 if BUILD_ISO_INFO
-iso_info_SOURCES = iso-info.c util.c util.h $(GETOPT_C)
+iso_info_SOURCES = iso-info.c util.c util.h
 iso_info_LDADD   = $(LIBISO9660_LIBS) $(LIBCDIO_LIBS) $(LTLIBICONV)
 bin_iso_info     = iso-info
 man_iso_info     = iso-info.1
 endif
 
 if BUILD_ISO_READ
-iso_read_SOURCES = iso-read.c util.c util.h $(GETOPT_C)
+iso_read_SOURCES = iso-read.c util.c util.h
 iso_read_LDADD   = $(LIBISO9660_LIBS) $(LIBCDIO_LIBS) $(LTLIBICONV)
 bin_iso_read     = iso-read
 man_iso_read     = iso-read.1
 endif
 
-mmc_tool_SOURCES = mmc-tool.c util.c util.h $(GETOPT_C)
+mmc_tool_SOURCES = mmc-tool.c util.c util.h
 mmc_tool_LDADD   = $(LIBISO9660_LIBS) $(LIBCDIO_LIBS) $(LTLIBICONV)
 bin_mmc_tool     = mmc-tool
 
@@ -81,7 +79,7 @@ INCLUDES = -I$(top_srcdir) $(LIBCDIO_CFLAGS) $(VCDINFO_CFLAGS) $(CDDB_CFLAGS)
 
 man_MANS = $(man_cd_drive) $(man_cd_info) $(man_cd_read) $(man_iso_read) $(man_iso_info)
 EXTRA_DIST = cd-drive.help2man cd-info.help2man cd-read.help2man \
-             iso-info.help2man iso-read.help2man $(GETOPT_C) getopt.h \
+             iso-info.help2man iso-read.help2man \
              $(man_MANS)
 
 if MAINTAINER_MODE
diff --git a/src/cd-drive.c b/src/cd-drive.c
index c179da9..744d7ba 100644
--- a/src/cd-drive.c
+++ b/src/cd-drive.c
@@ -24,7 +24,6 @@
 #ifdef HAVE_SYS_TYPES_H
 #include <sys/types.h>
 #endif
-#include "getopt.h"
 #include <cdio/cdio.h>
 #include <cdio/mmc.h>
 
diff --git a/src/cd-info.c b/src/cd-info.c
index f66cf98..38c3914 100644
--- a/src/cd-info.c
+++ b/src/cd-info.c
@@ -23,7 +23,6 @@
 */
 
 #include "util.h"
-#include "getopt.h"
 
 #ifdef HAVE_STDARG_H
 #include <stdarg.h>
diff --git a/src/cd-read.c b/src/cd-read.c
index 4e9a6bb..1d4473c 100644
--- a/src/cd-read.c
+++ b/src/cd-read.c
@@ -31,8 +31,6 @@
 #include <errno.h>
 #endif
 
-#include "getopt.h"
-
 /* Configuration option codes */
 enum {
   OP_HANDLED = 0,
diff --git a/src/cdda-player.c b/src/cdda-player.c
index f3ae0ce..2a8e57c 100644
--- a/src/cdda-player.c
+++ b/src/cdda-player.c
@@ -75,7 +75,6 @@
 #include <cdio/logging.h>
 
 #include "cddb.h"
-#include "getopt.h"
 
 static void action(const char *psz_action);
 static void display_cdinfo(CdIo_t *p_cdio, track_t i_tracks, 
diff --git a/src/iso-info.c b/src/iso-info.c
index b4c04b9..1cc5dd0 100644
--- a/src/iso-info.c
+++ b/src/iso-info.c
@@ -17,7 +17,6 @@
 /*
   ISO Info - prints various information about a ISO 9660 image.
 */
-#include "getopt.h"
 #include "util.h"
 #undef err_exit
 
diff --git a/src/iso-read.c b/src/iso-read.c
index 4820887..5cc28af 100644
--- a/src/iso-read.c
+++ b/src/iso-read.c
@@ -42,8 +42,6 @@
 #include <unistd.h>
 #endif
 
-#include "getopt.h"
-
 /* Used by `main' to communicate with `parse_opt'. And global options
  */
 static struct arguments
diff --git a/src/mmc-tool.c b/src/mmc-tool.c
index 77fb67c..e995566 100644
--- a/src/mmc-tool.c
+++ b/src/mmc-tool.c
@@ -35,7 +35,6 @@
 #include <cdio/cdio.h>
 #include <cdio/mmc.h>
 #include <cdio/mmc_cmds.h>
-#include "getopt.h"
 
 static void
 init(const char *argv0) 